package com.logicbig.example;

import javax.persistence.*;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

@Entity
public class Employee {
    @Id
    @GeneratedValue
    private long id;
    private String name;
    @ElementCollection
    @CollectionTable(name = "EMP_TASKS", joinColumns = @JoinColumn(name = "EMP_ID"))
    @MapKeyJoinColumn(name = "TASK_ID")
    @Column(name = "TASK_DATE")
    private Map<Task, Date> taskMap;

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Map<Task, Date> getTaskMap() {
        return taskMap;
    }

    public void setTaskMap(Map<Task, Date> tasks) {
        this.taskMap = tasks;
    }

    public void addTask(Date taskDate, Task task) {
        if (taskMap == null) {
            taskMap = new HashMap<>();
        }
        taskMap.put(task, taskDate);
    }

    @Override
    public String toString() {
        return "Employee{" +
                "id=" + id +
                ", name='" + name + '\'' +
                ", taskMap=" + taskMap +
                '}';
    }
}